/***********************************************************************
 * Copyright (c) 2003 University of Kent.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.cs.kent.ac.uk/projects/ocl/CPL.html
 ***********************************************************************/

/**
 * 
 * @author Octavian Patrascoiu
 *
 */

package uk.ac.kent.cs.ocl20.semantics.analyser;

import uk.ac.kent.cs.kmf.util.ILog;
import uk.ac.kent.cs.ocl20.semantics.bridge.Environment;
import uk.ac.kent.cs.ocl20.semantics.model.contexts.ContextDeclaration;
import uk.ac.kent.cs.ocl20.syntax.ast.contexts.ContextDeclarationAS;

public interface OclSemanticAnalyser {
	/** Semantic analysis */
	public ContextDeclaration analyse(ContextDeclarationAS decl, Environment env);

	/** Semantic analysis */
	public ContextDeclaration analyse(ContextDeclarationAS decl, Environment env, ILog log);

	/** Semantic analysis */
	public ContextDeclaration analyse(ContextDeclarationAS decl, Environment env, ILog log, boolean debugFlag);

	/** Check if the analyser encountered errors */
	public boolean hasErrors();
}
