/***********************************************************************
 * Copyright (c) 2003 University of Kent.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.cs.kent.ac.uk/projects/ocl/CPL.html
 ***********************************************************************/

/**
 *
 *  Class Environment.java
 *
 *  Generated by KMFStudio at 09 May 2003 17:49:05
 *  Visit http://www.cs.ukc.ac.uk/kmf
 *
 */

package uk.ac.kent.cs.ocl20.semantics.bridge;

import java.util.List;
import java.util.Set;

import uk.ac.kent.cs.ocl20.semantics.SemanticsElement;

public interface Environment
extends
    SemanticsElement
{
	/** Get the 'namedElements' from 'Environment' */
	public Set getNamedElements();
	/** Set the 'namedElements' from 'Environment' */
	public void setNamedElements(Set namedElements);

	/** Get the 'parent' from 'Environment' */
	public Environment getParent();
	/** Set the 'parent' from 'Environment' */
	public void setParent(Environment parent);

	/** Operation  'lookupLocal' from 'Environment' */
	public NamedElement lookupLocal(String name);

	/** Operation  'lookup' from 'Environment' */
	public ModelElement lookup(String name);

	/** Operation  'lookupPathName' from 'Environment' */
	public ModelElement lookupPathName(List names);

	/** Operation  'addElement' from 'Environment' */
	public Environment addElement(String name, ModelElement elem, Boolean imp);

	/** Add a variable into the 'Environment' */
	Environment addVariableDeclaration(String name, Classifier type, Boolean imp);
	
	/** Operation  'addEnvironment' from 'Environment' */
	public Environment addEnvironment(Environment env);

	/** Operation  'addNamespace' from 'Environment' */
	public Environment addNamespace(Namespace ns);

	/** Operation  'lookupImplicitProperty' from 'Environment' */
	public Property lookupImplicitProperty(String name);

	/** Operation  'lookupImplicitSourceForProperty' from 'Environment' */
	public NamedElement lookupImplicitSourceForProperty(String name);

	/** Operation  'lookupImplicitOperation' from 'Environment' */
	public Operation lookupImplicitOperation(String name, List types);

	/** Operation  'nestedEnvironment' from 'Environment' */
	public Environment nestedEnvironment();

	/** Operation  'lookupPathName' from 'Environment' */
	public Operation lookupPathName(List names, List types);

	/** Operation  'lookupImplicitSourceForOperation' from 'Environment' */
	public NamedElement lookupImplicitSourceForOperation(String name, List types);

	/** Override the toString */
	public String toString();

	/** Clone the object */
	public Object clone();
}
