/***********************************************************************
 * Copyright (c) 2003 University of Kent.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.cs.kent.ac.uk/projects/ocl/CPL.html
 ***********************************************************************/

package uk.ac.kent.cs.ocl20.standard.lib;

public abstract class OclAnyImpl implements OclAny {
	protected StdLibAdapter adapter;
	protected OclAnyImpl(StdLibAdapter adapter) {
		this.adapter = adapter;
	}

	//--- IOclAny ---
	public OclBoolean equalTo(OclAny object2) {
		return adapter.Boolean(this.equals(object2));
	}

	public OclBoolean notEqualTo(OclAny object2) {
		return this.equalTo(object2).not();
	}
	
	public OclBoolean oclIsNew() {
		return this.adapter.Boolean(false);
	}

	public Object oclAsType(OclType type) {
		return this;
	}

	public OclBoolean oclIsTypeOf(OclType type) {
		boolean b1 = ((Class)type.asJavaObject()).isAssignableFrom( this.asJavaObject().getClass() );
		boolean b2 = (this.asJavaObject().getClass()).isAssignableFrom( (Class)type.asJavaObject() );
		return adapter.Boolean(b1 && b2);
	}

	public OclBoolean oclIsKindOf(OclType type) {
		boolean b = ((Class)type.asJavaObject()).isAssignableFrom( this.asJavaObject().getClass() );
		return adapter.Boolean(b);
	}

	public OclBoolean oclIsInState(Object state) {
		return this.adapter.Boolean(false);
	}
	public OclBoolean oclIsUndefined() {
		return this.adapter.Boolean(false);
	}

	public OclSet allInstances() {
		return null;
	}

	public String toString(Class[] x) {
		String str = "(";
		for(int i=0; i<x.length; i++) {
			str+=x[i].getName();
			if (i+1<x.length) str+="' ";
		}
		str+=")";
		return str;
	}

	//--- Object ---
	public abstract Object clone();
	public abstract boolean equals(Object o);
	public int hashCode() {
		return 0;
	}
}
