/***********************************************************************
 * Copyright (c) 2003 University of Kent.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.cs.kent.ac.uk/projects/ocl/CPL.html
 ***********************************************************************/

package uk.ac.kent.cs.ocl20.standard.lib;

public class OclStringImpl extends OclAnyImpl implements OclString {
	public OclStringImpl(java.lang.String s, StdLibAdapter adapter) {
		super(adapter);
		_implementation = s;
	}

	String _implementation;
	public String implementation() {
		return _implementation;
	}

	public Object asJavaObject() {
		return implementation();
	}
	//--- IOclString ---
	public OclBoolean equalTo(OclString string2) {
		return adapter.Boolean(implementation().equals(((OclStringImpl) string2).implementation()));
	}

	public OclInteger size() {
		return adapter.Integer(implementation().length());
	}

	public OclString concat(OclString string2) {
		return adapter.String(implementation() + ((OclStringImpl) string2).implementation());
	}

	public OclString substring(OclInteger lower, OclInteger upper) {
		return adapter.String(implementation().substring(adapter.impl(lower).intValue()-1, adapter.impl(upper).intValue()-1 + 1));
	}
	
	public OclInteger toInteger() {
		return adapter.Integer( Integer.parseInt(implementation()) );
	}

	public OclReal toReal() {
		return adapter.Real( Double.parseDouble(implementation()) );
	}

	//--- IOclVisitable ---
	public Object accept(OclVisitor v, Object obj) {
		return v.visit(this, obj);
	}
	//--- Object ---
	public String toString() {
		return "'" + _implementation + "'";
	}

	public boolean equals(Object o) {
		return (o instanceof OclString) ? adapter.impl(equalTo((OclString)o)).booleanValue() : false;
	}

	public int hashCode() {
		return implementation().hashCode();
	}

	public Object clone() {
		return adapter.String(_implementation);
	}
}
