/***********************************************************************
 * Copyright (c) 2003 University of Kent.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.cs.kent.ac.uk/projects/ocl/CPL.html
 ***********************************************************************/

package uk.ac.kent.cs.ocl20.synthesis;

import java.util.List;

import uk.ac.kent.cs.kmf.util.ILog;
import uk.ac.kent.cs.ocl20.semantics.model.contexts.ContextDeclaration;

/**
 * 
 * @author Octavian Patrascoiu
 *
 */
public interface OclEvaluator {
	/** Evaluate contexts into a specific environment */
	public List evaluate(ContextDeclaration context, RuntimeEnvironment renv);

	/** Evaluate contexts into a specific environment */
	public List evaluate(ContextDeclaration context, RuntimeEnvironment renv, ILog log);
}
